#include <stdlib.h>
#include <stdio.h>
#include "oware.h"

int main(int argc, char *argv[])
{
  int side1[houses+1];
  int side2[houses+1];
  int move;

  if (argc != 2*houses+4) {
    fprintf(stderr,"%s <move> <side1-1>...<side1-6> <score1> <side2-1>...<side2-6> <score2>\n<move> in 1..6\n",argv[0]);
    exit(1);
  }
  move=atoi(argv[1])-1; /* program-internal moves are 0-5, input/output: 1-6 */
  if (cmdline2pos(argc-2,argv+2,side1,side2)==0) {
    fprintf(stderr,"this should not happen\n");
    exit(1);
  }
  printf("Old position:\n");
  printboard(side1,side2);
  printf("\n");
  if (plyfull(move,side1,side2)==0) {
    fprintf(stderr,"invalid move\n");
    exit(1);
  }
  if (side1[houses]==draw && side2[houses]==draw) {
    printf("Game over: draw\n");
    exit(0);
  }
  if (side1[houses]>draw) {
    printf("Game over: This side wins %d:%d\n", side1[houses],side2[houses]);
    exit(0);
  }
  if (side2[houses]>draw) {
    printf("Game over: Other side wins %d:%d\n", side2[houses],side1[houses]);
    exit(0);
  }
  printf("New position:\n");
  printboard(side1,side2);
  printf("\ninput for opponent move:\n");
  for (int i=0; i<=houses; i++)
    printf("%d ", side2[i]);
  for (int i=0; i<=houses; i++)
    printf("%d ", side1[i]);
  printf("\n");
  return 0;
}

